/* ===========================================================================
                      Backtracking: POWERSET
The program uses the module for lists in the file `list_module.cpp'
c is the cardinality of the given set s. pc is 2 to the power c, that is, pc
is the cardinality of the powerset.
=========================================================================== */
#include  <iostream.h>
typedef int Values;
#include "list_module.cpp"      // We have lists of int
const int c=3; const int pc=8;  // c=cardinality of the set s, pc=2^c

int id=0; int n=0; // global variables
int s [c]={5,7,4}; // s is the given set, represented as an array
list s1=NULL;      // s1 is a subset of the given set s
int Exists[c];     // array of 0's and 1's.
list ps [pc];      // ps is the powerset, represented as an array of lists
//----------------------------------------------------------------------------
void printar(int A[], int size)
{for (int i=0; i<size; i=i+1) {cout << A[i] << " ";} }

void printarasset(int A[], int size)
{cout << "{ "; for (int i=0; i<size; i=i+1) {cout << A[i] << " ";};
 cout << "}";}

void printset(list L)
{if (L == NULL) {cout << ""; return;}
 else {cout << head(L) << " "; printset(tail(L));};}

void PrintPowerSet(list ps[], int size)
{cout << "{"; for (int i=0; i<size; i=i+1)
              {cout << "{ "; printset(ps[i]);
               cout << "}"; if (i<size-1) {cout << ",\n ";};};
cout << "\n}";}
//----------------------------------------------------------------------------
void Select(list &s1)     // &s1 : changes to s1 are made also 'outside'
{s1=NULL;
 for (int i=0; i<c; i=i+1) {if (Exists[i]==1) {s1=cons(s[i],s1);};}}

void generate()
{int ib=1;
do {Exists[id]=ib-1; id=id+1;
   if (id==c) {printar(Exists,c); cout << "\n"; Select(s1); ps[n]=s1; n++;}
               else generate();
   id=id-1;
   ib=ib+1;}
while (ib<3);}            // <-- 3, not c!
//----------------------------------------------------------------------------
void main()
{cout << "The given set is:\n"; printarasset(s,c); cout << "\n\n";
 cout << "Values of the array Exists:\n"; generate(); cout << "\n";
 cout << "The powerset of the given set is:\n";
 PrintPowerSet(ps,pc); cout << "\n";
}
/* input:      output:
------------------------------------------------------------------------------
               The given set is:
               { 5 7 4 }

               Values of the array Exists:
               0 0 0
               0 0 1
               ...
               1 1 1

               The powerset of the given set is:
               {{ },
                { 4 },
                { 7 },
                { 4 7 },
                { 5 },
                { 4 5 },
                { 7 5 },
                { 4 7 5 }
               }
---------------------------------------------------------------------------- */
